(function (win) {
    var comboBoxDecorator = Base.extend({

        DecorateElement: function (properties) {

            this.DecorateControl(String.format("#{0}", properties.GetElementName()), properties);
        },

        DecorateControl: function (controlId, properties) {

            if (properties.ConsoleLogEnabled)
                console.log(String.format("Enter Combobox DecorateControl - {0} ms", new Date().getTime()));

            var elementCSS = null;

            if (properties.DCss != null && properties.DCss != undefined && properties.DCss.trim() != '') {
                elementCSS = properties.DCss;
            }
            else {
                elementCSS = properties.CSS;
            }

            var root = $(String.format("div[root='root_{0}']", properties.ControlId));

            if (!properties.IsVisible) {
                root.hide();
                return;
            }

            root.show();

            properties.Name = properties.GetElementName();

            var selectedKey = null;
            var selectedVal = null;
            var selectedval2 = null;
            var selectedval3 = null;

            if (properties.DataSource != null && properties.DataSource.length > 0) {
                for (var i = 0; i < properties.DataSource.length; i++) {
                    if (properties.DataSource[i].Key == properties.ControlValue ||
                        properties.DataSource[i].Value._firstValue == properties.ControlValue ||
                        properties.DataSource[i].Value._secondValue == properties.ControlValue ||
                        properties.DataSource[i].Value._thirdValue == properties.ControlValue) {
                        selectedKey = properties.DataSource[i].Key;
                        selectedVal = properties.DataSource[i].Value._firstValue;
                        selectedval2 = properties.DataSource[i].Value._secondValue;
                        selectedval3 = properties.DataSource[i].Value._thirdValue;
                        break;
                    }
                }
            }
            var resultarr = [];
            for (var i = 0; i < properties.DataSource.length; i++) {
                resultarr.push({
                    id: properties.DataSource[i].Key,
                    text: properties.DataSource[i].Value._firstValue,
                    text2: properties.DataSource[i].Value._secondValue,
                    text3: properties.DataSource[i].Value._thirdValue
                });
            }
            resultarr.shift();
            if (selectedKey == null) {
                if (properties.DataValue != null) {
                    if (properties.DataValue.length > 0) {
                        selectedKey = properties.DataValue[0].Key;
                        selectedVal = properties.DataSource[0].Value._firstValue;
                        selectedval2 = properties.DataSource[0].Value._secondValue;
                        selectedval3 = properties.DataSource[0].Value._thirdValue;
                    }
                }
            }

            var cssText = this.BuildCss(properties);

            this.LoadedComboDestroy(properties.ControlId);

            var lblComboBox = jQuery(String.format("#lbl_{0}", properties.ControlId));
            var manBox = jQuery(String.format("#man_{0}", properties.ControlId));
            var comboContainer = jQuery("#" + properties.ControlId + " .controls");

            var crlComboBox = jQuery("#sel_" + properties.ControlId);

            jQuery(controlId).remove(); //Remove span of render type 0
            crlComboBox.remove(); //Remove div of render type 1
            switch (properties.RenderType) {
                //span
                case 13:
                case 14:
                    //selectedVal = (selectedVal == null) ? "" : selectedVal;

                    //if (properties.RenderType == 13) {
                    //    comboContainer.html("<span id=\"" + properties.Name + "\">" + selectedVal + "</span>");
                    //}
                    //else {
                    //    comboContainer.html("<dv id=\"" + properties.Name + "\">" + selectedVal + "</dv>");
                    //}

                    crlComboBox = jQuery(controlId);
                    crlComboBox.css('cssText', cssText);

                    if (elementCSS != null && elementCSS.trim() != '') {
                        var css = elementCSS;
                        css = css.replace("btn", "").replace("btn-default", "").replace("btn-xs", "");
                        crlComboBox.removeClass().addClass(css);
                    }

                    if (properties.TemplateClasses != null
                        && properties.TemplateClasses.length > 0) {
                        jQuery.each(properties.TemplateClasses, function (i, cls) {
                            if (!crlComboBox.hasClass(cls)) {
                                crlComboBox.addClass(cls);
                            }
                        });
                    }
                    break;

                default:
                    var comboBoxHtml = "<div id=\"sel_" + properties.ControlId + "\"  data-toggle=\"popover\" data-placement=\"auto\" data-trigger=\"hover\"  data-content=\"" + properties.ToolTip + "\"><input id=\"" + properties.Name + "\" Name=\"" + properties.Name
                        + "\" class=\"bootstrap-input\" tabindex=\"" + properties.TabIndex + "\" data-width=\"100%\" data-live-search=\"true\" data-style=\"btn-default btn-Custom-xs\" ></input></div>";



                    comboContainer.html(comboBoxHtml);

                    var crlcombo = jQuery(String.format("#{0}", properties.GetElementName()));


                    var option = "";

                    var starttime = new Date().getTime();

                    if (properties.consoleLogEnabled)
                        console.log(String.format("decorate  - {0} before datasource - {1} ms", properties.ElementControlType, starttime));


                    var fieldType = ''
                    if (properties.EnableTooltip == 1)
                        fieldType = { text: 'text', value: 'id', tooltip: 'text3' }
                    else
                        fieldType = { text: 'text', value: 'id' }


                    var ComboBox = new ej.dropdowns.DropDownList({
                        placeholder: 'Select',
                        filterBarPlaceholder: 'Search',
                        dataSource: resultarr,
                        popupHeight: '250px',
                        allowFiltering: true,
                        filterType: 'contains',
                        change: triggerChange,
                        fields: fieldType
                    });

                    if (properties.InputType == 2) {

                        ComboBox.valueTemplate = '<div style="width:100%;height:100%;">'
                            + '<img class="value" src="${text2}" height="26px" width="26px"/>'
                            + '<div class="name"> ${text} </div></div>';
                        ComboBox.itemTemplate = '<div><img class="empImage" src="${text2}"/>' +
                            '<div class="ename"> ${text} </div>';

                    }

                    ComboBox.appendTo('#cmb_' + properties.ControlId);

                    if (properties.EnableTooltip == 1) {
                        var tooltip = new ej.popups.Tooltip({
                            // default content of tooltip
                            // content: 'Loading...',
                            // set target element to tooltip
                            target: '.e-list-item',
                            // set position of tooltip
                            position: 'top center',
                            beforeRender: function (args) {
                                // controlId = controlId.replace('#', '');
                                var listElement = document.getElementById('cmb_' + properties.ControlId);
                                var result = listElement.ej2_instances[0].dataSource;
                                var i;
                                for (i = 0; i < result.length; i++) {
                                    if (result[i].text === args.target.textContent.trim()) {
                                        this.content = result[i].text3;
                                        this.dataBind();
                                    }
                                }
                            },
                        });
                        tooltip.appendTo('body');
                    }

                    function triggerChange() {
                        if (properties.DFSEvents != null &&
                            properties.DFSEvents.length > 0 &&
                            (properties.RenderType == 12 || properties.RenderType == undefined)) {

                            var evtName;

                            for (var i = 0; i < properties.DFSEvents.length; i++) {

                                if (properties.DFSEvents[i] == null)
                                    continue;

                                evtName = properties.DFSEvents[i];

                                onDFSEvent(controlId, evtName);

                            }
                        }
                    }


                    if (properties.consoleLogEnabled)
                        console.log(String.format("decorate End - {0} after - {1} ms", properties.ElementControlType, new Date().getTime() - starttime));

                    if (selectedKey != null) {
                        crlcombo.selectpicker('val', selectedKey);
                        crlcombo.val(selectedKey);
                    }

                    var crlBtn = jQuery(String.format("#sel_{0} button", properties.ControlId));

                    crlBtn.css('cssText', cssText);

                    if (elementCSS != null && elementCSS.trim() != '') {
                        var classes = crlBtn.attr("class");
                        var newCls = classes;
                        if (classes != null) {
                            if (classes.indexOf(elementCSS) == -1) {
                                // don't remove default classes
                                if (classes.indexOf("dropdown-toggle") == -1) {
                                    newCls += " dropdown-toggle ";
                                }
                                newCls += elementCSS;

                                newCls = newCls.replace('bootstrap-input bs-input-hidden', '')
                                crlBtn.removeClass().addClass(newCls);
                            }
                        }
                    }

                    if (!properties.IsSmartUI && !properties.ViewOnly) {
                        if (!properties.IsEnable) {
                            crlcombo.attr('disabled', "disabled");
                            crlBtn.addClass("disabled");
                            crlcombo.selectpicker('refresh');
                        }
                        else {
                            crlcombo.removeAttr('disabled');
                            crlBtn.removeClass("disabled");
                            crlcombo.selectpicker('refresh');
                        }

                    }
                    else {
                        crlcombo.attr('disabled', "disabled");
                        crlBtn.attr('disabled', "disabled");
                        crlBtn.addClass("disabled");
                    }

                    if (properties.TemplateClasses != null
                        && properties.TemplateClasses.length > 0) {
                        jQuery.each(properties.TemplateClasses, function (i, cls) {
                            if (!crlBtn.hasClass(cls)) {
                                crlBtn.addClass(cls);
                            }
                        });
                    }

                    crlComboBox = jQuery("#sel_" + properties.ControlId);
                    break;
            }

            if (properties.IsMandatory)
                manBox.html("*");
            else
                manBox.html("");

            if (properties.ShowCaption) {
                lblComboBox.text(properties.Caption);
                lblComboBox.show();
            }
            else {
                lblComboBox.hide();
            }

            var rootElement = jQuery("div[root='root_" + properties.ControlId + "']");

            if (properties.Wrap != null) {

                var wrapControlId = rootElement;
                var elementClass = wrapControlId.attr("class");

                var rgx = /col-md-[0-9]*/g;

                if (properties.ColumnClass == "xs")
                    rgx = /col-xs-[0-9]*/g;
                else if (properties.ColumnClass == "sm")
                    rgx = /col-sm-[0-9]*/g;
                else if (properties.ColumnClass == "md")
                    rgx = /col-md-[0-9]*/g;
                else if (properties.ColumnClass == "lg")
                    rgx = /col-lg-[0-9]*/g;

                if (elementClass != undefined && elementClass != null
                    && elementClass.match(rgx)) {
                    wrapControlId.removeClass(function (index, css) {
                        return (css.match(rgx) || []).join(' ');
                    });
                }

                if (properties.Wrap > 0) {
                    wrapControlId.addClass(String.format("col-" + properties.ColumnClass + "-{0}", properties.Wrap));
                }
            }

            if (properties.ClearFix) {
                rootElement.before("<div class=\"clearfix\"></div>");
            }
            else {
                var element = rootElement.prev();

                if (element.hasClass("clearfix")) {
                    element.remove();
                }
            }

            if (properties.DFSEvents != null &&
                properties.DFSEvents.length > 0 &&
                (properties.RenderType == 12 || properties.RenderType == undefined)) {
                this.SubscribeEvents(properties, crlcombo, controlId);
            }

            $("[data-toggle=popover]").popover();

            if (properties.DataSource != null && properties.DataSource != undefined && properties.DataSource.length > 0) {
                if (properties.DataValue != undefined) {
                    $("#sel_" + properties.ControlId + ' li').each(function (index) {
                        if (properties.DataSource.length > index) {
                            $(this).attr('title', properties.DataSource[index].Value);
                        }
                    });
                }
                else {
                    $("#sel_" + properties.ControlId + ' li').each(function (index) {
                        $(this).attr('title', properties.DataSource[index].Value);
                    });
                }
            }

            if (properties.ConsoleLogEnabled)
                console.log(String.format("Exit Combobox DecorateControl - {0} ms", new Date().getTime()));
        },

        BuildCss: function (properties) {
            var cssText = '';

            if (properties.BackColor != null && properties.BackColor.trim() != '')
                cssText += 'background-color: ' + properties.BackColor + ' !important;';

            if (properties.BorderColor != null && properties.BorderColor.trim() != '')
                cssText += 'border-color: ' + properties.BorderColor + ' !important;';

            if (properties.BorderStyleText != null && properties.BorderStyleText.trim() != '')
                cssText += 'border-style: ' + properties.BorderStyleText.split('-')[0].trim().toLowerCase() + ' !important;';

            if (properties.BorderWidth > 0)
                cssText += 'border-width: ' + properties.BorderWidth + 'px !important;';

            if (properties.FontName != null && properties.FontName.trim() != '')
                cssText += 'font-family: ' + properties.FontName + ' !important;';

            if (properties.FontSize > 0)
                cssText += 'font-size: ' + properties.FontSize + 'px !important;';

            if (properties.FontBold)
                cssText += 'font-weight: bold !important;';

            if (properties.FontItalic)
                cssText += 'font-style: italic !important;';

            if (properties.FontOverLine || properties.FontStrikeOut || properties.FontUnderLine)
                cssText += 'text-decoration: ';

            if (properties.FontOverLine)
                cssText += 'overline ';

            if (properties.FontStrikeOut)
                cssText += 'line-through ';

            if (properties.FontUnderLine)
                cssText += 'underline ';

            if (properties.FontOverLine || properties.FontStrikeOut || properties.FontUnderLine)
                cssText += '!important;';

            if (properties.ForeColor != null && properties.ForeColor.trim() != '')
                cssText += 'color: ' + properties.ForeColor + ' !important;';

            if (properties.Width > 0)
                cssText += 'width: ' + properties.Width + 'px !important;';

            if (properties.Height > 0)
                cssText += 'height: ' + properties.Height + 'px !important;';

            cssText += 'border-radius: 3px;';

            return cssText;
        },

        SubscribeEvents: function (properties, ctrl, controlId) {

            var evtName;

            for (var i = 0; i < properties.DFSEvents.length; i++) {

                if (properties.DFSEvents[i] == null)
                    continue;

                evtName = properties.DFSEvents[i];

                ctrl.on('change', function () {
                    onDFSEvent(controlId, evtName);
                });
            }

        },

        LoadedComboDestroy: function (ctrlId) {

            jQuery(String.format("#sel_{0}", ctrlId)).off("mouseout").off("mouseover");
            jQuery(String.format("#sel_{0} .btn-group.bootstrap-select", ctrlId)).off("click").off("touchstart");
            jQuery(String.format("#sel_{0} .btn-group.bootstrap-select", ctrlId)).off("hidden").off("shown");
            jQuery(String.format("#sel_{0} .btn-group.bootstrap-select", ctrlId)).off("hide").off("show");
            jQuery(String.format("#sel_{0} button", ctrlId)).off("click").off("keyup");
            jQuery(String.format("#sel_{0} .dropdown-menu", ctrlId)).off("click");

            jQuery(String.format("#cmb_{0}", ctrlId)).off("change");
            jQuery(String.format("#cmb_{0}", ctrlId)).selectpicker('destroy');
        },

        Destroy: function (ctrlid) {
            jQuery("#" + ctrlid + " select").off();
            jQuery("#" + ctrlid + " select").selectpicker('destroy');
        }

    });

    win.ComboBoxDecorator = comboBoxDecorator;

})(window);



